using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace JasonListBox
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			this.SetStyle(ControlStyles.ResizeRedraw, true);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.listBox1.BackColor = System.Drawing.Color.White;
			this.listBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.listBox1.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable;
			this.listBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.listBox1.ItemHeight = 40;
			this.listBox1.Location = new System.Drawing.Point(24, 80);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(432, 274);
			this.listBox1.TabIndex = 0;
			this.listBox1.DrawItem += new System.Windows.Forms.DrawItemEventHandler(this.listBox1_DrawItem);
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(480, 64);
			this.label1.TabIndex = 1;
			this.label1.Text = "Nice Gradient Label!";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.label1.Paint += new System.Windows.Forms.PaintEventHandler(this.label1_Paint);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(480, 373);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.listBox1);
			this.Name = "Form1";
			this.Text = "Fancy and Cool Drawing Tricks";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region OwnerDraw ListBox

		string[] items = new string[] { "Hello", "Infragistics", "Cool", "World" };
		Color[] color = new Color[4] {Color.Brown, Color.Blue, Color.Green, Color.Orange};

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.listBox1.Items.AddRange(items);
		}

		private void listBox1_DrawItem(object sender, 
			System.Windows.Forms.DrawItemEventArgs e)
		{
			// Draw the default background
			// of the control
			e.DrawBackground();
			
			// Cast a variable for the sender
			ListBox l = (ListBox) sender;			

			// Create and draw brush for the backcolor
			Brush b = new SolidBrush(l.BackColor);
			e.Graphics.FillRectangle(b, e.Bounds);

			// Dispose of the brush object
			b.Dispose();

			Rectangle rect = e.Bounds;
			rect.Inflate(-2,-2);

			//draw select background with the fancy
			// gradient, as well as the rounded
			// edges using the GetRoundBox method
			if ((e.State&DrawItemState.Selected) > 0) 
			{
				Brush br = this.GetGradienBrush(rect, 
					Color.Red, Color.White);
				e.Graphics.FillPath(br, 
					this.GetRoundBox(rect,10));
				br.Dispose();
			}		

			// Get the size of the selected item,
			// and draw the text of the selected item 
			// into the ListBox
			string text = items[e.Index];
			SizeF sz = e.Graphics.MeasureString(text, l.Font);
			Brush tb = new SolidBrush(color[e.Index]);
			Font fnt = new Font(FontFamily.GenericSansSerif, 
				14, FontStyle.Bold);
			e.Graphics.DrawString(text, fnt, tb, e.Bounds.X +5, 
				e.Bounds.Y+(e.Bounds.Height-sz.Height)/2);
			tb.Dispose();

		}

		private GraphicsPath GetRoundBox(Rectangle rect, 
			int roundness) 
		{

			// Create a GraphicsPath object which
			// represents a series of lines and curves
			// to create a shape
			GraphicsPath result = new GraphicsPath();

			if (roundness > 1) 
			{
				// Get a floating point number
				// from the roundness parameter, used
				// to create the SizeF struct's values
				roundness = Math.Min(Math.Min(rect.Width, 
					rect.Height)/3, roundness);
				float diameter = roundness * 2.0F; 
				SizeF sizeF = new SizeF( diameter, diameter );

				// Create a rectangleF struct
				// with the the size of the ListBox
				RectangleF arc = new 
					RectangleF( rect.Location, sizeF ); 

				// Create and add a series of
				// curves for the right, left, top
				// and bottom of the ListBox, at 
				// the coordinates determined by the
				// Rectangle
				result.AddArc( arc, 180, 90 ); 
				arc.X = rect.Right-diameter; 
				result.AddArc( arc, 270, 90 ); 
				arc.Y = rect.Bottom-diameter; 
				result.AddArc( arc, 0, 90 ); 
				arc.X = rect.Left;     
				result.AddArc( arc, 90, 90 );     

				// Make sure the final line is drawn
				// from the last drawn line to the
				// first drawn line
				result.CloseFigure(); 
			}
			else 
			{
				result.AddRectangle(rect);
			}

			return result;
		}

		private Brush GetGradienBrush(Rectangle bgp, 
			Color Color1, Color Color2) 
		{
			Brush result = new LinearGradientBrush( bgp, 
				Color1, Color2, 90.0f, true );
			(result as LinearGradientBrush).SetBlendTriangularShape(0.5f, .6f );
			return result;
		}

		private void Form1_Paint(object sender, 
			System.Windows.Forms.PaintEventArgs e)
		{

			// Get a Rectangle object that represents 
			// the bounds of the ListBox
			Rectangle rect = this.listBox1.Bounds;

			// call the Inflate method, which can inflate the 
			// rectangle, or take a height and width to expand 
			// the bounds of the listbox with circular edges
			 rect.Inflate(10,10);

			// Draw the GraphicsPath object 
			// around the Listbox.  
			// The GetRoundBox method takes 
			// the rectangle of the Listbox 
			// and the roundness for the corners
			e.Graphics.DrawPath(Pens.Red, 
				this.GetRoundBox(rect, 10));
		}
		#endregion

		#region Gradient labels

		private void label1_Paint(object sender, 
				System.Windows.Forms.PaintEventArgs e)
		{

			// Cast the object to a label
			Label l = (Label) sender;	
	
			// Get the location and size of the 
			// rectangle of the label
			Rectangle rect = new 
				Rectangle(0, 0, l.Width, l.Height);

			/* This is a simple example of a gradient, 
			 you can uncomment this code to see a 
			 Horizontal gradient

			LinearGradientBrush lgb = new LinearGradientBrush(
				rect,
				Color.Blue,
				Color.Green,
				LinearGradientMode.Horizontal);
			e.Graphics.FillRectangle(lgb, rect);
			return;	*/


			// Create a Brush object, using 2 colors,
			// the size of the rectangle (which
			// is the size of the label, and create 
			// a gradient brush using GetGradientBrush
			Brush br = this.GetGradienBrush
				(rect, Color.DarkBlue, Color.LightBlue);
			
			// Fill the Graphics object of this label 
			// with the Brush object, and the 
			// roundness that you wish the label 
			// to contain (default will be 0)
			
			//e.Graphics.FillPath(br, 
			//	this.GetRoundBox(rect,10));
			
			
			// Fill the rectangle area of the 
			// label.  To see how to create a 
			// rounded label, comment out this 
			// line of code and uncomment to 
			// code above
			e.Graphics.FillRectangle(br, rect);

			// Create a new font object
			Font fnt = new Font
				(FontFamily.GenericSansSerif, 
				14, FontStyle.Bold);
			
			// Measure the size of the text based 
			// on the previously created
			// font object to properly display 
			// on the label
			SizeF sz = e.Graphics.MeasureString
				 (l.Text, fnt);

			// Draw the text onto the label using 
			// the font you created, the 
			// color white, and place the 
			// text within the center bounds of the
			// label, 5 points off the left edge
			e.Graphics.DrawString
				(l.Text, fnt, Brushes.White,  
				l.Bounds.X +5, 
				l.Bounds.Y+
				(l.Bounds.Height-sz.Height)/2);
		}		

		#endregion

	}
}
